#ifndef DEVICES_PRONET_H
#define DEVICES_PRONET_H
/*
**	pronet.device V2 include file
*/

#ifndef EXEC_IO_H
#include "exec/io.h"
#endif

#define PNDERR_PORTEXISTS	-94
#define PNDERR_BADCONFIG	-95
#define PNDERR_DRIVERTROUBLE	-96

struct PNRequest {
   struct IORequest pnr_Request;
   struct MsgPort *pnr_MsgPort;
   UWORD pnr_NetSourcePort;

   UWORD pnr_NetDestPort;
   UBYTE *pnr_Data1;
   ULONG pnr_Length1;
   UBYTE *pnr_Data2;
   ULONG pnr_Length2;
};

/*
 pnr_MsgPort		Messageport where data sent from the other machine
			will be sent to.
 pnr_NetSourcePort	Logical Portnumber of the device-user.
 ^^ Both values must be specified at device-opening time and must remain
    until closing the device.

 pnr_NetDestPort	Messageport where the data is to be sent to.
 pnr_Data1/2		Length of both data added must NOT be higher
 pnr_Length1/2		than $4000 (16K) - if you just want to send
			one chunk of data, make pnr_Length2 = 0
*/

#define PNP_NAME	-1
#define PNP_NEXTFREE	-2

#define PND_WRITE	3

#endif	/* DEVICES_PRONET_H */
